;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; LC_LZ2 -> LC_LZ3 Decompression Routine Replacement
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HEADER
LOROM

!Freespace = $178000|$800000

!S = $D8			; 0x10 bytes in $7E00XX that aren't touched during interrupts (NMI or IRQ)

macro ReadByte()
	STX $8A
	LDA [$8A]
	INX
	BNE +
	LDX #$8000
	INC.b $03+!S
	INC $8C
+
endmacro

org $80B8E3
	JSL CodeStart		;was JML before
	RTS
	
org !Freespace
	reset bytes
	db "STAR"
	dw CodeEnd-CodeStart-$01
	dw CodeEnd-CodeStart-$01^$FFFF

CodeStart:
	PHB
	PEI ($00+!S)
	PEI ($02+!S)
	PEI ($04+!S)
	PEI ($06+!S)
	PEI ($08+!S)
	PEI ($0A+!S)
	PEI ($0C+!S)
	PEI ($0E+!S)
	PEI ($8A)
	SEP #$20
	REP #$10
	LDA $02
	PHA
	PLB
	STA.b $02+!S	; dest_bank (direct-copy)
	STA.b $0B+!S	; dest_bank (indirect-copy)
	STA.b $0C+!S	; src_bank (indirect-copy)
	INC
	STA.b $00+!S	; dest_bank [plus or minus]
	LDA #$54
	STA.b $01+!S	; mvn (direct-copy)
	STA.b $0A+!S	; mvn (indirect-copy)
	LDA #$4C
	STA.b $04+!S	; jmp (direct-copy)
	STA.b $0D+!S	; jmp (indirect-copy)
	LDA $8C
	STA.b $03+!S	; src_bank (direct-copy)
	LDX.w #.back
	STX.b $05+!S	; jmp to (direct-copy)
	LDX.w #.back2
	STX.b $0E+!S	; jmp to (indirect-copy)
	
	LDY $00		; dest_low
	LDX $8A		; src_low
	STZ $8A
	STZ $8B
	JMP .main
	
.end
	PLX : STX $8A
	PLX : STX.b $0E+!S
	PLX : STX.b $0C+!S
	PLX : STX.b $0A+!S
	PLX : STX.b $08+!S
	PLX : STX.b $06+!S
	PLX : STX.b $04+!S
	PLX : STX.b $02+!S
	PLX : STX.b $00+!S
	REP #$20
	TYA
	SEC
	SBC.b $00
	STA $8D		; size!!!
	SEP #$30
	PLB
	RTL			;JML $80B8EA

.case_c0
	%ReadByte()
	CMP #$00
	BPL +
	STY.b $08+!S
	REP #$21
	AND #$007F
	EOR #$FFFF
	ADC.b $08+!S
	SEP #$20
	BRA .lzcopy110
+	XBA
	%ReadByte()
	REP #$21
	ADC.b $00
	SEP #$20
	
.lzcopy110
	STX.b $08+!S
	TAX
-	LDA $0000,x
	STA $0000,y
	INY
	DEX
	DEC $8D
	BPL -
	JMP .back2

.case_e0_or_else
	ASL
	BPL .case_c0
	LDA $8D
	CMP #$1F
	BEQ .end

	AND #$03
	STA $8E
	EOR $8D
	ASL
	ASL
	ASL
	XBA
	%ReadByte()
	STA $8D
	XBA
	JMP .type

.case_80_or_else
	BMI .case_e0_or_else
	ASL
	BMI .case_a0

	%ReadByte()
	CMP #$00
	BPL +
	STY.b $08+!S
	REP #$21
	AND #$007F
	EOR #$FFFF
	ADC.b $08+!S
	BRA .lzcopy
+	XBA
	%ReadByte()
	REP #$21
	ADC.b $00
	
.lzcopy
	STX.b $08+!S
	TAX
	LDA $8D
	SEP #$20
	JMP $000A+!S

.case_80_or_else_J
	JMP .case_80_or_else

.case_a0
	%ReadByte()
	CMP #$00
	BPL +
	STY.b $08+!S
	REP #$21
	AND #$007F
	EOR #$FFFF
	ADC.b $08+!S
	SEP #$20
	BRA .lzcopy101
+	XBA
	%ReadByte()
	REP #$21
	ADC.b $00
	SEP #$20
	
.lzcopy101
	STX.b $08+!S
	TAX
-	LDA $0000,x
	STZ.b $07+!S
	ASL
	ROR.b $07+!S
	ASL
	ROR.b $07+!S
	ASL
	ROR.b $07+!S
	ASL
	ROR.b $07+!S
	ASL
	ROR.b $07+!S
	ASL
	ROR.b $07+!S
	ASL
	ROR.b $07+!S
	ASL
	LDA.b $07+!S
	ROR
	STA $0000,y
	INY
	INX
	DEC $8D
	BPL -

.back2
	LDX.b $08+!S
	
.main
	%ReadByte()
	STA $8D
	STZ $8E
	AND #$E0
	TRB $8D

.type
	ASL
	BCS .case_80_or_else_J
	BMI .case_40_or_60
	ASL
	BMI .case_20

.case_00
	REP #$20
	LDA $8D
	STX $8D
	
-	SEP #$20
	JMP $0001+!S
	
.back
	CPX $8D
	BCS .main
	
	INC.b $03+!S
	INC $8C
	CPX #$0000
	BEQ ++
	
	DEX
	STX.b $08+!S
	REP #$21
	LDX #$8000
	STX $8D
	TYA
	SBC.b $08+!S
	TAY
	LDA.b $08+!S
	BRA -
	
++	LDX #$8000
	BRA .main

.case_20
	%ReadByte()
	STX.b $08+!S
	PHA
	PHA
	REP #$20
	
.case_20_main
	LDA $8D
	INC
	LSR
	TAX
	PLA
	
-	STA $0000,Y
	INY
	INY
	DEX
	BNE -
	
	SEP #$20
	BCC +
	STA $0000,Y
	INY
+	LDX.b $08+!S
	BRA .main
	
.case_40_or_60
	ASL
	BMI .case_60
	%ReadByte()
	XBA
	%ReadByte()

	XBA
	STX.b $08+!S
	REP #$20
	PHA
;Replace BRA .case_20_main the code itself
	LDA $8D
	INC
	LSR
	TAX
	PLA
-	STA $0000,Y
	INY
	INY
	DEX
	BNE -
	SEP #$20
	BCC +
	STA $0000,Y
	INY
+	LDX.b $08+!S
	JMP .main
	
.case_60	
	REP #$20
	
.case_60_main
	STX.b $08+!S
	LDA $8D
	INC
	LSR
	TAX
	LDA.w #$0000

-	STA $0000,Y
	INY
	INY
	DEX
	BNE -
	
	SEP #$20
	BCC +
	STA $0000,Y
	INY
+	LDX.b $08+!S
	JMP .main

CodeEnd:
print "Insert Size: ",bytes," bytes"